Index: trunk/contactcenter/inc/class.so_group.inc.php
===================================================================
--- trunk/contactcenter/inc/class.so_group.inc.php	(revision 702)
+++ trunk/contactcenter/inc/class.so_group.inc.php	(revision 752)
@@ -26,8 +26,7 @@
 		function select($id = '')
 		{
-			$query = 'SELECT id_group,title,short_name FROM phpgw_cc_groups WHERE owner = '.$this->owner;
-			
+			$query = 'SELECT id_group,title,short_name FROM phpgw_cc_groups ';
 			if($id != '')
-				$query .= ' AND id_group ='.$id;
+				$query .= 'WHERE id_group ='.$id;
 			
 			$query .= ' ORDER BY title';
@@ -44,5 +43,4 @@
 				$return[] = $this->db->row(); 
 			}
-	
 			
 			return $return;
@@ -189,5 +187,6 @@
 			'A.id_contact = B.id_contact and B.id_connection = C.id_connection '.
 			'and B.id_typeof_contact_connection = 1 and '.
-			'A.id_owner ='.$this->owner.' and D.id_connection = C.id_connection and D.id_group = '.$idGroup.
+			//'A.id_owner ='.$this->owner.' and'.
+			' D.id_connection = C.id_connection and D.id_group = '.$idGroup.
 			' order by A.names_ordered';
 						
Index: trunk/contactcenter/inc/class.bo_shared_group_manager.inc.php
===================================================================
--- trunk/contactcenter/inc/class.bo_shared_group_manager.inc.php	(revision 752)
+++ trunk/contactcenter/inc/class.bo_shared_group_manager.inc.php	(revision 752)
@@ -0,0 +1,228 @@
+<?php
+  /***************************************************************************\
+  * eGroupWare - Contacts Center                                              *
+  * http://www.egroupware.org                                                 *
+  * Written by:                                                               *
+  *  - Raphael Derosso Pereira <raphaelpereira@users.sourceforge.net>         *
+  *  sponsored by Thyamad - http://www.thyamad.com
+  * ------------------------------------------------------------------------- *
+  *  This program is free software; you can redistribute it and/or modify it  *
+  *  under the terms of the GNU General Public License as published by the    *
+  *  Free Software Foundation; either version 2 of the License, or (at your   *
+  *  option) any later version.                                               *
+  \***************************************************************************/
+
+	include_once('class.abo_catalog.inc.php');
+	class bo_shared_group_manager extends abo_catalog
+	{
+			
+		var $fields = array(
+			'id_group'    	=> true,
+			'title'       			=> true,			
+			'short_name'	=> true,
+			'owner'	=> true
+		);
+	
+		/*!
+		
+		 @function bo_group_manager
+		 @abstract Constructor
+	 	 @author Raphael Derosso Pereira
+	 	 
+	 	*/
+		function bo_shared_group_manager()
+		{
+			$this->init();		
+			
+		}
+
+		/*!
+			@function find
+			@abstract Find function for this catalog
+			@author Raphael Derosso Pereira
+
+		*/
+
+	function find($what, $rules=false, $other=false)
+		{
+			$so_contact = CreateObject('contactcenter.so_contact',  $GLOBALS['phpgw_info']['user']['account_id']);
+			$relacionados = $so_contact->get_relations();
+			
+			$array_retorno = array();
+			$array_map = array();
+			$rules_inicio = $rules;
+			
+			foreach($relacionados as $uid_relacionado => $tipo_relacionamento) {
+				$aclTemp = CreateObject("phpgwapi.acl",$uid_relacionado); 
+				$aclTemp->read();
+				//	Preciso verificar as permissões que o contato relacionado deu para o atual
+				$perms_relacao = $aclTemp->get_specific_rights($GLOBALS['phpgw_info']['user']['account_id'],'contactcenter'); 
+				//	Se não tiver permissão de leitura, nem se preocupe em listá-los
+				if(!(($perms_relacao&1) && $tipo_relacionamento == 1)) {									
+					continue;
+				}
+				$found = false;
+				
+				if (is_array($what) && count($what)) {
+					foreach ($what as $id => $value) {
+						if (strpos($value, 'group') === 0) {
+							$found = true;
+							break;
+						}
+					}
+				}
+				if (!$found) {
+					return $this->sql_find($what, $rules, $other);
+				}
+				
+				if(!$rules)
+					$rules = array();
+
+				array_push($rules, array(	
+					'field' => 'group.owner',	
+					'type'  => '=',	
+					'value' => $uid_relacionado	)
+					);
+
+				$array_temp = $this->sql_find($what, $rules, $other);
+				if(count($array_retorno)==0) {
+					$array_map = $this->cria_aux($array_temp);
+					if($array_map) foreach($array_temp as $valor_retorno) {
+						$valor_retorno['perms'] = $perms_relacao;
+						$valor_retorno['owner'] = $uid_relacionado;
+						array_push($array_retorno,$valor_retorno);
+					}
+				}
+				else {
+					if($array_temp) foreach($array_temp as $value) {							
+						$value['perms'] = $perms_relacao;
+						$value['owner'] = $uid_relacionado;
+						$array_map[$value["title"]] = 1;
+						array_push($array_retorno,$value);
+					}
+				}				
+				$rules = $rules_inicio;
+			}
+			
+			usort($array_retorno, array($this, "compareTreeNodes"));			
+			return $array_retorno;
+		}		
+		
+		function compareTreeNodes($a, $b)	{					
+			return strnatcasecmp($a['title'], $b['title']);
+		}
+		
+		function cria_aux($array) {
+			$retorno = array();
+			if($array) foreach($array as $valor) {
+				$retorno[$valor["title"]] = 1;
+			}
+			return $retorno;
+		}
+		
+		 	
+		/*!
+		 
+		 @function get_multiple_entries
+		 @abstract Returns multiple Contacts data into one array
+		 @author Raphael Derosso Pereira
+
+		 @param array $id_contacts The Contacts IDs
+		 @param array $fields The Contacts fields to be retrieved
+		 @param array $other_data Other informations. The format is:
+		 	$other_data = array(
+		 		'offset'    => <offset>,
+		 		'limit'     => <max_num_returns>,
+		 		'sort'      => <sort>,
+		 		'order_by'  => <order by>
+		 	); 
+		
+		*/
+		function get_multiple_entries ( $id_groups, $fields, $other_data = false )
+		{
+				
+			$groups = array();
+			foreach ($id_groups as $id)
+			{
+				$group = $this->get_single_entry($id,$fields);				
+				if ($group)
+				{
+					$groups[] = $group;
+				}
+			}			
+			
+			return $groups;
+	
+		}
+
+		/*!
+		
+			@function get_all_entries_ids
+			@abstract Returns the IDs of all the entries in this catalog
+			@author Raphael Derosso Pereira
+
+		*/
+		function get_all_entries_ids ()
+		{
+			
+			$search_fields = array('group.id_group', 'group.title');
+			$search_other  = array('order' => 'group.title');
+			
+			$search_rules = array();
+			array_push($search_rules, array(
+					'field' => 'group.owner',
+					'type'  => '=',
+					'value' => $GLOBALS['phpgw_info']['user']['account_id']
+				));			
+
+			$result_i = $this->find($search_fields, $search_rules, $search_other);
+			
+
+			if (is_array($result_i) and count($result_i))
+			{
+				$result = array();
+				foreach($result_i as $result_part)
+				{
+					$result[] = $result_part['id_group'];
+				}
+												
+				return $result;
+			}
+			
+			return null;
+		}
+		
+		function get_single_entry ( $id, $fields )
+		{	
+			
+			if (!is_array($fields)) 
+			{
+				if (is_object($GLOBALS['phpgw']->log)) 
+				{
+					$GLOBALS['phpgw']->log->message(array(
+						'text' => 'F-BadcontactcenterParam, wrong get_single_entry parameters type.',
+						'line' => __LINE__,
+						'file' => __FILE__));
+					
+					$GLOBALS['phpgw']->log->commit();
+				}
+				else 
+				{
+					exit('Argument Error on: <br>File:'.__FILE__.'<br>Line:'.__LINE__.'<br>');
+				}
+			}
+
+			$soGroup = CreateObject('contactcenter.so_group');			
+			$group = $soGroup -> select($id);			
+			 return $group[0];						
+		}
+		
+	
+		function get_contacts_by_group ( $id )
+		{
+			$soGroup = CreateObject('contactcenter.so_group');			
+			return $soGroup -> selectContactsByGroup($id);
+		}
+	
+}
+?>
Index: trunk/contactcenter/inc/class.ui_data.inc.php
===================================================================
--- trunk/contactcenter/inc/class.ui_data.inc.php	(revision 702)
+++ trunk/contactcenter/inc/class.ui_data.inc.php	(revision 752)
@@ -70,6 +70,8 @@
 			if($this->page_info['actual_catalog']['class'] == 'bo_group_manager')
 				$this -> typeContact = 'groups';
-			else if($this->page_info['actual_catalog']['class'] == 'bo_shared_catalog_manager')
-				$this -> typeContact = 'shared';
+			else if($this->page_info['actual_catalog']['class'] == 'bo_shared_group_manager')
+				$this -> typeContact = 'shared_groups';
+			else if($this->page_info['actual_catalog']['class'] == 'bo_shared_people_manager')
+				$this -> typeContact = 'shared_contacts';
 			else
 				$this -> typeContact = 'contacts';
@@ -150,4 +152,5 @@
 			/* Messages */
 			$GLOBALS['phpgw']->template->set_var('cc_msg_not_allowed',lang('Not Allowed'));
+			$GLOBALS['phpgw']->template->set_var('cc_msg_unavailable',lang('Unavailable function'));			
 			$GLOBALS['phpgw']->template->set_var('cc_msg_no_cards',lang('No Cards'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_err_no_room',lang('No Room for Cards! Increase your browser area.'));
@@ -583,5 +586,6 @@
 				switch ($this->page_info['actual_catalog']['class'])
 				{
-					case 'bo_shared_catalog_manager':
+					case 'bo_shared_people_manager':
+					case 'bo_people_catalog':
 						$field_name = 'id_contact';
 
@@ -593,93 +597,13 @@
 									'type'  => 'iLIKE',
 									'value' => $letter !== 'all' ? $letter.'%' : '%'
-								)
+								)								
 							);
-						}
-						else
-						{
-							$find_restric[0] = array(
-								0 => array(
-									'type'  => 'branch',
-									'value' => 'OR',
-									'sub_branch' => array(
-										0 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '0%'
-										),
-										1 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '1%'
-										),
-										2 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '2%'
-										),
-										3 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '3%'
-										),
-										4 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '4%'
-										),
-										5 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '5%'
-										),
-										6 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '6%'
-										),
-										7 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '7%'
-										),
-										8 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '8%'
-										),
-										9 => array(
-											'field' => 'contact.names_ordered',
-											'type'  => 'LIKE',
-											'value' => '9%'
-										)
-									)
-								)
-							);
-						}
-						
-						$find_field[0] = array('contact.id_contact','contact.names_ordered');
-						
-						$find_other[0] = array(
-							'order'  => 'contact.names_ordered'
-						);
-						
-						break;
-					case 'bo_people_catalog':
-						$field_name = 'id_contact';
-
-						if ($letter !== 'number')
-						{
-							$find_restric[0] = array(
-								0 => array(
-									'field' => 'contact.names_ordered',
-									'type'  => 'iLIKE',
-									'value' => $letter !== 'all' ? $letter.'%' : '%'
-								),
-								1 => array(
-									'field' => 'contact.id_owner',
-									'type'  => '=',
-									'value' => $GLOBALS['phpgw_info']['user']['account_id']
-								)
-							);
+							if($this->page_info['actual_catalog']['class'] == 'bo_people_catalog'){								
+								$find_restric[0][1] = array(
+										'field' => 'contact.id_owner',
+										'type'  => '=',
+										'value' => $GLOBALS['phpgw_info']['user']['account_id']
+								);
+							}
 						}
 						else
@@ -741,18 +665,20 @@
 										),
 									),
-								),
-								1 => array(
-									'field' => 'contact.id_owner',
-									'type'  => '=',
-									'value' => $GLOBALS['phpgw_info']['user']['account_id']
-								),
+								)
 							);
 						}
+
+						if($this->page_info['actual_catalog']['class'] == 'bo_people_catalog'){								
+							$find_restric[0][1]	= array(
+								'field' => 'contact.id_owner',
+								'type'  => '=',
+								'value' => $GLOBALS['phpgw_info']['user']['account_id']
+							);
+						}
+						
 						
 						$find_field[0] = array('contact.id_contact','contact.names_ordered');
 						
 						$find_other[0] = array(
-							//'offset' => (($page-1)*$this->page_info['n_cards']),
-							//'limit'  => $this->page_info['n_cards'],
 							'order'  => 'contact.names_ordered'
 						);
@@ -985,5 +911,6 @@
 
 					case 'bo_group_manager':
-					
+					case 'bo_shared_group_manager':
+												
 						$field_name = 'id_group';
 						
@@ -1009,18 +936,19 @@
 						}
 						
-						array_push($find_restric[0],  array(
+						if($this->page_info['actual_catalog']['class'] == 'bo_group_manager'){
+							array_push($find_restric[0],  array(
 											'field' => 'group.owner',
 											'type'  => '=',
 											'value' => $GLOBALS['phpgw_info']['user']['account_id']										
-								)
-						);
+									)
+							);
+						}
 						
 						$find_field[0] = array('group.id_group','group.title','group.short_name');						
 						$find_other[0] = array(
 							'order'  => 'group.title'
-						);
-						
+						);						
 						break;
-						
+					
 					case 'bo_catalog_group_catalog':
 						$this->page_info['actual_entries'] = false;
@@ -1038,4 +966,5 @@
 				
 				$result = $this->bo->find($find_field[0],$find_restric[0],$find_other[0]);
+				
 				$n_entries = count($result);
 				
@@ -1052,4 +981,5 @@
 				if (!$result)
 				{
+					
 					$this->page_info['actual_entries'] = false;
 					
@@ -1068,8 +998,8 @@
 					foreach ($result as $id => $value)
 					{
-						if($this->page_info['actual_catalog']['class'] != 'bo_shared_catalog_manager')
+						if($this->page_info['actual_catalog']['class'] != 'bo_shared_people_manager' && $this->page_info['actual_catalog']['class'] != 'bo_shared_group_manager')
 							$this->page_info['actual_entries'][] = $value[$field_name];
 						else
-							$this->page_info['actual_entries'][] = array(0=>$value[$field_name],1=>$value['perms']);
+							$this->page_info['actual_entries'][] = array(0=>$value[$field_name],1=>$value['perms'],2=>$value['owner']);
 					} 
 					//print_r($this->page_info['actual_entries']);
@@ -1136,5 +1066,5 @@
 						5 => 'cc_alias',
 						6 => 'cc_id',
-						7 => 'cc_forwarding_address'
+						7 => 'cc_forwarding_address'						
 					)
 				);
@@ -1147,9 +1077,10 @@
 				//echo 'ID_I: '.$id_i.'<br>';
 				//echo 'ID_F: '.$id_f.'<br>';
-				///---------------- Correção Temporária PHP5 -----------------------///
+				
 				$ids = array();
 				$perms = array();
+				$owners = array();
 				$array_temp = array();			
-								
+				
 				foreach($this->page_info['actual_entries'] as $key=>$tmp){
 						$array_temp[] = $tmp;				
@@ -1158,13 +1089,39 @@
 				for($i = $id_i; $i < $id_f and $i < $n_entries; $i++)
 				{
-					if($this->page_info['actual_catalog']['class'] != 'bo_shared_catalog_manager')
+					if($this->page_info['actual_catalog']['class'] != 'bo_shared_people_manager' && $this->page_info['actual_catalog']['class'] != 'bo_shared_group_manager')
 						$ids[] = $array_temp[$i];
 					else {
 						$ids[] = $array_temp[$i][0];
 						$perms[] = $array_temp[$i][1];
+						$owners[] = $array_temp[$i][2];
 					}
 					//$perms[] = $array_temp[$i];
 				}
 				
+				
+				// Carrega o nome completo dos donos dos objetos (contatos e grupos);
+				$owner_names = array();
+							
+				if($owners) {
+					$filter = "(|";
+					foreach($owners as $i => $owner) {
+						$filter .= "(uidNumber=".$owner.")";
+					}
+					$filter .= ")";
+					
+					if(!$this->bo->catalog->src_info) {
+						$ldap = CreateObject('contactcenter.bo_ldap_manager');
+						$this->bo->catalog->src_info = $ldap->srcs[1];
+					}
+					$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], false);				
+					$dn=$this->bo->catalog->src_info['dn'];
+					$justThese = array("cn","uidnumber","uid");
+					$sr = ldap_search($ds,$dn, $filter,$justThese);								
+					$info = ldap_get_entries($ds, $sr);
+					ldap_close($ds);											
+					for($z = 0; $z < $info['count']; $z++) {
+						$owner_names[$info[$z]['uidnumber'][0]] = array("cn" => $info[$z]['cn'][0], "uid" => $info[$z]['uid'][0]);
+					}				
+				}
 				/// Original
 				//for($i = $id_i; $i < $id_f and $i < $n_entries; $i++)
@@ -1175,6 +1132,5 @@
 				
 				$fields = $this->bo->catalog->get_fields(false);
-
-				if( $this->typeContact == 'groups') {
+				if( $this->typeContact == 'groups' || $this->typeContact == 'shared_groups') {
 					$final = array(
 						0 => (int)$this->page_info['n_pages'],
@@ -1187,13 +1143,12 @@
 						)						
 					);					
-					
 					$groups =& $this->bo->catalog->get_multiple_entries($ids,$fields);
-					
+															
 					$i = 0;
 					// contatos do grupo
 					$boGroups = CreateObject('contactcenter.bo_group');					
 					$contacts = array();
-					foreach($groups as $group)		{
-										
+					
+					foreach($groups as $group)		{	
 						$final[3][$i][0] = $group['title'] ? $group['title'] : 'none';
 						$final[3][$i][1] = $group['short_name'] ? $group['short_name'] : 'none';						
@@ -1201,4 +1156,9 @@
 						$contacts = $boGroups -> get_contacts_by_group($group['id_group']);
 						$final[3][$i][3] = $contacts;
+						$final[3][$i][4] = $perms[$i];
+						if($this->typeContact == 'shared_groups'){
+							$final[3][$i][5] = lang('Shared').": ".$owner_names[$owners[$i]]['cn'];
+							$final[3][$i][6] = $owner_names[$owners[$i]]['uid'];
+						}						
 						$i++;							
 					}
@@ -1210,6 +1170,6 @@
 					$lnk_compose = "location.href=('../expressoMail1_2/index.php?to=";
 					
-					$final[5] = '<span class="link"  onclick="'.$lnk_compose;
-					$final[10] = 'groups';																												
+					$final[5] = '<span class="link"  onclick="'.$lnk_compose;					
+					$final[10] = $this->typeContact;																										
 					$this->save_session();					
 					echo serialize($final);
@@ -1301,6 +1261,7 @@
 							$final[3][$i][7] = array();
 							
-						if($this->page_info['actual_catalog']['class']=='bo_shared_catalog_manager') {
+						if($this->page_info['actual_catalog']['class']=='bo_shared_people_manager') {
 							$final[3][$i][8] = $perms[$i];
+							$final[3][$i][9] = lang('Shared').": ".$owner_names[$owners[$i]]['cn'];
 						}
 
@@ -1373,6 +1334,7 @@
 				}
 			}
-			$data['contact_list'] = $contact_options;
-			$data['result'] = 'ok';								
+			$data['contact_list'] = $contact_options;			
+			$data['result'] = 'ok';
+											
 			echo serialize($data);			
 		}		
@@ -2315,5 +2277,6 @@
 			if ($this->page_info['actual_catalog']['class'] != 'bo_people_catalog' &&
 				$this->page_info['actual_catalog']['class'] != 'bo_group_manager' &&
-				$this->page_info['actual_catalog']['class'] != 'bo_shared_catalog_manager')
+				$this->page_info['actual_catalog']['class'] != 'bo_shared_people_manager' &&
+				$this->page_info['actual_catalog']['class'] != 'bo_shared_group_manager')
 			{
 
@@ -2349,5 +2312,6 @@
 				if (!$external && $this->page_info['actual_catalog']['class'] != 'bo_people_catalog' &&
 					$this->page_info['actual_catalog']['class'] != 'bo_group_manager' &&
-					$this->page_info['actual_catalog']['class'] != 'bo_shared_catalog_manager')
+					$this->page_info['actual_catalog']['class'] != 'bo_shared_people_manager' &&					
+					$this->page_info['actual_catalog']['class'] != 'bo_shared_group_manager' )
 				{
 					/*
@@ -2395,5 +2359,6 @@
 			if ($external || $this->page_info['actual_catalog']['class'] == 'bo_people_catalog' ||
 				$this->page_info['actual_catalog']['class'] == 'bo_group_manager' ||
-				$this->page_info['actual_catalog']['class'] == 'bo_shared_catalog_manager')
+				$this->page_info['actual_catalog']['class'] == 'bo_shared_people_manager' ||
+				$this->page_info['actual_catalog']['class'] == 'bo_shared_group_manager'	)
 			{
 				// Get only this attributes: dn, cn for external catalogs,
@@ -2427,5 +2392,5 @@
             foreach ($ids as $e_info)
             {
-				if($this->page_info['actual_catalog']['class'] != 'bo_shared_catalog_manager')
+				if($this->page_info['actual_catalog']['class'] != 'bo_shared_people_manager' && $this->page_info['actual_catalog']['class'] != 'bo_shared_group_manager')
                 	$ids_f[] = $e_info[$id_field];
                 else
Index: trunk/contactcenter/inc/class.bo_contactcenter.inc.php
===================================================================
--- trunk/contactcenter/inc/class.bo_contactcenter.inc.php	(revision 498)
+++ trunk/contactcenter/inc/class.bo_contactcenter.inc.php	(revision 752)
@@ -350,9 +350,26 @@
  			if($_SESSION['phpgw_info']['user']['preferences']['contactcenter']['shared_contacts']){
 	 			$this->tree[2] = array('type' => 'sql');
-				$this->tree['branches'][2] = array('name' => lang('Shared'),
-										'type'       => 'catalog',
-										'class'      => 'bo_shared_catalog_manager',
+				$this->tree['branches'][2] = array(
+										'name' => lang('Shared'),
+										'type'       => 'mixed_catalog_group',
+										'class'      => 'bo_shared_people_manager',
 										'icon'       => 'people-mini.png',
-										'sub_branch' => false);
+										'sub_branch' => array( 
+											0 =>	array(	
+												'name' 	=> lang('People'),
+												'type' 	=> 'catalog',
+												'class' => 'bo_shared_people_manager',
+												'icon'  => 'people-mini.png',
+												'sub_branch' => False
+											),
+											1 =>	array(	
+												'name' 	=> lang('Groups'),
+												'type' 	=> 'catalog',
+												'class' => 'bo_shared_group_manager',
+												'icon'  => 'people-mini.png',
+												'sub_branch' => False
+											)
+										)
+							);
 				unset($_SESSION['phpgw_info']['user']['preferences']['contactcenter']['shared_contacts']);
  			}
@@ -419,6 +436,5 @@
 					$i++;
 				}
-			}
-			
+			}	
 			$GLOBALS['phpgw']->session->appsession('bo_contactcenter.tree','contactcenter',$this->tree);
 			return $this->tree['branches'];
@@ -599,5 +615,5 @@
 					$level = $this->get_level_by_branch($catalog, $this->tree['branches']);
 					$catalog =& $this->get_catalog_tree($level);
-
+				
 				case 'catalog':
 				case 'catalog_group':
